// Extensions.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(FoundationNetworking)
import FoundationNetworking
#endif

extension Bool: JSONEncodable {
    func encodeToJSON(codableHelper: CodableHelper) -> Any { self }
}

extension Float: JSONEncodable {
    func encodeToJSON(codableHelper: CodableHelper) -> Any { self }
}

extension Int: JSONEncodable {
    func encodeToJSON(codableHelper: CodableHelper) -> Any { self }
}

extension Int32: JSONEncodable {
    func encodeToJSON(codableHelper: CodableHelper) -> Any { self }
}

extension Int64: JSONEncodable {
    func encodeToJSON(codableHelper: CodableHelper) -> Any { self }
}

extension Double: JSONEncodable {
    func encodeToJSON(codableHelper: CodableHelper) -> Any { self }
}

extension Decimal: JSONEncodable {
    func encodeToJSON(codableHelper: CodableHelper) -> Any { self }
}

extension String: JSONEncodable {
    func encodeToJSON(codableHelper: CodableHelper) -> Any { self }
}

extension URL: JSONEncodable {
    func encodeToJSON(codableHelper: CodableHelper) -> Any { self }
}

extension UUID: JSONEncodable {
    func encodeToJSON(codableHelper: CodableHelper) -> Any { self }
}

extension RawRepresentable where RawValue: JSONEncodable {
    func encodeToJSON(codableHelper: CodableHelper) -> Any { return self.rawValue }
}

private func encodeIfPossible<T>(_ object: T, codableHelper: CodableHelper) -> Any {
    if let encodableObject = object as? JSONEncodable {
        return encodableObject.encodeToJSON(codableHelper: codableHelper)
    } else {
        return object
    }
}

extension Array: JSONEncodable {
    func encodeToJSON(codableHelper: CodableHelper) -> Any {
        return self.map { encodeIfPossible($0, codableHelper: codableHelper) }
    }
}

extension Set: JSONEncodable {
    func encodeToJSON(codableHelper: CodableHelper) -> Any {
        return Array(self).encodeToJSON(codableHelper: codableHelper)
    }
}

extension Dictionary: JSONEncodable {
    func encodeToJSON(codableHelper: CodableHelper) -> Any {
        var dictionary = [AnyHashable: Any]()
        for (key, value) in self {
            dictionary[key] = encodeIfPossible(value, codableHelper: codableHelper)
        }
        return dictionary
    }
}

extension Data: JSONEncodable {
    func encodeToJSON(codableHelper: CodableHelper) -> Any {
        return self.base64EncodedString(options: Data.Base64EncodingOptions())
    }
}

extension Date: JSONEncodable {
    func encodeToJSON(codableHelper: CodableHelper) -> Any {
        return codableHelper.dateFormatter.string(from: self)
    }
}

extension JSONEncodable where Self: Encodable {
    func encodeToJSON(codableHelper: CodableHelper) -> Any {
        guard let data = try? codableHelper.jsonEncoder.encode(self) else {
            fatalError("Could not encode to json: \(self)")
        }
        return data.encodeToJSON(codableHelper: codableHelper)
    }
}
